<template>
    <div>
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small" style="max-width: 500px;">
            <el-form-item prop="testName" label="名称">
                <template>
                    <el-select v-model="formData.testName" clearable placeholder="请选择" :disabled="'testName'==subColumn">
                        <el-option v-for="item in testNameOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item prop="remark" label="嗯嗯">
                <template>
                    <el-select v-model="formData.remark" clearable placeholder="请选择" :disabled="'remark'==subColumn">
                        <el-option v-for="item in remarkOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item prop="imageUrl" label="图片">
                <single-upload v-model="formData.imageUrl" :disabled="'imageUrl'==subColumn"></single-upload>
            </el-form-item>
            <el-form-item prop="testTime" label="时间">
                <template>
                    <div class="block">
                        <el-date-picker v-model="formData.testTime" type="date" value-format="timestamp" placeholder="选择日期" :disabled="'testTime'==subColumn">
                        </el-date-picker>
                    </div>
                </template>
            </el-form-item>
            <el-form-item prop="multiSelect" label="多选">
                <template>
                    <el-select v-model="formData.multiSelect" multiple clearable placeholder="请选择" :disabled="'multiSelect'==subColumn">
                        <el-option v-for="item in multiSelectOptions" :key="item.value" :label="item.label" :value="item.value">
                        </el-option>
                    </el-select>
                </template>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="$store.state.fetchingData" type="primary">保存</el-button>
                <el-button @click="onDelete" v-if="formData.id" type="danger">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
import formValidator from '../formValidator'

export default {
    created() {
        if (this.$route.query.column) {
            this.subColumn = this.$route.query.column.split(',')[1];
            this.subValue = this.$route.query.column.split(',')[0];
        }

        if (this.$route.query.id) {
            this.$http.get({
                url: '/testAaa/getOne',
                data: {
                    id: this.$route.query.id
                }
            }).then(res => {
                if (res.success) {


                    if (res.data.multiSelect) {
                        res.data.multiSelect = res.data.multiSelect.split(',');
                    } else {
                        res.data.multiSelect = [];
                    }


                    this.formData = res.data;

                    if (this.$route.query.column) {
                        this.formData[this.subColumn] = this.subValue;
                    }
                }
            })
        } else {
            if (this.$route.query.column) {
                this.formData[this.subColumn] = this.subValue;
            }
        }




        this.$http.get({
            url: '/testBbb/all'
        }).then(res => {
            if (res.success) {

                if (res.data.length > 0) {
                    res.data.forEach(item => {
                        this.remarkOptions.push({ label: item.nameAaa, value: item.nameAaa });
                    })
                }
            }
        });



        this.$http.get({
            url: '/testBbb/all'
        }).then(res => {
            if (res.success) {

                if (res.data.length > 0) {
                    res.data.forEach(item => {
                        this.multiSelectOptions.push({ label: item.nameCcc, value: item.nameCcc });
                    })
                }
            }
        });
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {
                testName:
                    [
                        { required: true, message: '请输入 名称', trigger: 'blur' },
                    ],
                remark:
                    [
                        { required: true, message: '请输入 嗯嗯', trigger: 'blur' },
                    ],
                multiSelect:
                    [
                        { required: true, message: '请输入 多选', trigger: 'blur' },
                    ],
            },
            testNameOptions: [{ label: '??', value: '??' }, { label: '??', value: '??' }, { label: '??', value: '??' }],
            remarkOptions: [],
            multiSelectOptions: [],
            subColumn: '',
            subValue: '',
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate((valid) => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            var data = JSON.parse(JSON.stringify(this.formData));
            this.$http.post({
                url: this.formData.id ? '/testAaa/update' : '/testAaa/save',
                data: data
            }).then(res => {
                if (res.success) {
                    this.$message.success('成功');
                    this.$router.go(-1);
                } else {
                    this.$message.warning('失败')
                }
            });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' }).then(() => {
                return this.$http.post({
                    url: '/testAaa/del',
                    data: { id: this.formData.id }
                })
            }).then(() => {
                this.$message.success('删除成功');
                this.$router.go(-1);
            }).catch(action => {
                if (action === 'cancel') {
                    this.$message.info('删除取消');
                } else {
                    this.$message.error('删除失败');
                }
            })
        },
    }
}
</script>
<style lang="less" scoped>
</style>
